export function toObjectArray(dataReaderTable) {
    const objects = new Array();
    dataReaderTable.rows.forEach((row) => {
        const object = {};
        for (let index = 0; index < dataReaderTable.columns.length; index++) {
            const column = dataReaderTable.columns[index];
            if (column.datatype === "Date") {
                const value = row[index];
                if (value) {
                    object[column.field] = new Date(value);
                }
                else {
                    object[column.field] = null;
                }
            }
            else {
                object[column.field] = row[index];
            }
        }
        objects.push(object);
    });
    return objects;
}
//# sourceMappingURL=dataReaderTable.js.map